package com.adventurer_engine.common.gadgets;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.util.Tools;
import java.util.HashMap;
import java.util.Map;
import nb;
import net.minecraft.entity.DirtyEntityAccessor;
import net.minecraftforge.event.entity.living.LivingEvent;
import nj;
import nn;
import of;

public class AdditionBombs {
  private float damage;
  
  private float percent;
  
  private int delay;
  
  private of attacker;
  
  private nj[] effects;
  
  private String sound;
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setDamage(float damage) {
    this.damage = damage;
    return this;
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setPercent(float percent) {
    this.percent = percent;
    return this;
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setDelay(int delay) {
    this.delay = delay;
    return this;
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setAttacker(of attacker) {
    this.attacker = attacker;
    return this;
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setEffects(nj[] effects) {
    this.effects = effects;
    return this;
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs setSound(String sound) {
    this.sound = sound;
    return this;
  }
  
  public static nb causeBombDamage(nn entity) {
    return (nb)new DamageSourceAdditionBomb("additionBomb", entity);
  }
  
  public void trigger(of entity) {
    nb source = causeBombDamage((nn)this.attacker);
    float ratio = 1.0F;
    ratio *= this.damage;
    if (entity.aN() - ratio > 0.0F) {
      DirtyEntityAccessor.damageEntity(entity, source, ratio);
    } else {
      entity.a(source, ratio);
    } 
    if (this.effects != null && Tools.percent(this.percent))
      for (nj p : this.effects) {
        if (!entity.i(p.a()))
          entity.c(new nj(p)); 
      }  
    entity.af = 0;
    if (this.sound != null) {
      float volume = Tools.random.nextFloat() * 0.4F + 0.5F;
      float frequency = 1.0F / (Tools.random.nextFloat() * 0.4F + 0.5F);
      this.attacker.q.a((nn)entity, this.sound, volume, frequency);
    } 
  }
  
  public com.adventurer_engine.common.gadgets.AdditionBombs copy() {
    nj[] copyEffects = new nj[this.effects.length];
    for (int i = 0; i < copyEffects.length; i++)
      copyEffects[i] = new nj(this.effects[i].a(), (this.effects[i]).b, this.effects[i].c()); 
    com.adventurer_engine.common.gadgets.AdditionBombs toRet = new com.adventurer_engine.common.gadgets.AdditionBombs();
    toRet.damage = this.damage;
    toRet.percent = this.percent;
    toRet.delay = this.delay;
    toRet.attacker = this.attacker;
    toRet.effects = copyEffects;
    toRet.sound = this.sound;
    return toRet;
  }
  
  private static Map<of, LinkedBombs> bombs = new HashMap<of, LinkedBombs>();
  
  public static void onUpdate(LivingEvent.LivingUpdateEvent event) {
    of entity = event.entityLiving;
    if (entity == null)
      return; 
    if (!bombs.containsKey(entity))
      return; 
    if (event.entityLiving.M) {
      bombs.remove(event.entityLiving);
      return;
    } 
    LinkedBombs head = bombs.get(entity);
    head.v.delay--;
    for (LinkedBombs b = head.next; b != head; b = b.next)
      b.v.delay--; 
    boolean firstTime = true;
    boolean headChanged = false;
    while (head.v.delay == 0) {
      head.v.trigger(entity);
      if (firstTime) {
        bombs.remove(entity);
        firstTime = false;
      } 
      if (head.next == head)
        break; 
      head.next.prev = head.prev;
      head.prev.next = head.next;
      head = head.next;
      headChanged = true;
    } 
    if (head.v.delay != 0) {
      if (headChanged)
        bombs.put(entity, head); 
      for (LinkedBombs linkedBombs = head.next; linkedBombs != head; linkedBombs = linkedBombs.next) {
        if (linkedBombs.v.delay == 0) {
          linkedBombs.v.trigger(entity);
          linkedBombs.next.prev = linkedBombs.prev;
          linkedBombs.prev.next = linkedBombs.next;
        } 
      } 
    } 
  }
  
  public static void addBomb(of entity, com.adventurer_engine.common.gadgets.AdditionBombs bomb) {
    if (bombs.containsKey(entity)) {
      LinkedBombs l = new LinkedBombs(null);
      l.v = bomb;
      LinkedBombs head = bombs.get(entity);
      l.prev = head;
      l.next = head.next;
      head.next.prev = l;
      head.next = l;
    } else {
      LinkedBombs l = new LinkedBombs(null);
      l.v = bomb;
      l.prev = l;
      l.next = l;
      bombs.put(entity, l);
    } 
  }
}
